#!/bin/bash
#
# opensm:		Manage OpenSM
#
#     SUSE system startup script for OpenSM
#     Copyright (C) 1995--2009  John Jolly, SUSE / Novell Inc.
#          
#     This library is free software; you can redistribute it and/or modify it
#     under the terms of the GNU Lesser General Public License as published by
#     the Free Software Foundation; either version 2.1 of the License, or (at
#     your option) any later version.
#			      
#     This library is distributed in the hope that it will be useful, but
#     WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#     Lesser General Public License for more details.
#      
#     You should have received a copy of the GNU Lesser General Public
#     License along with this library; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
#     USA.
#
# /etc/init.d/opensmd
#   and its symbolic link
# /(usr/)sbin/rcopensmd
#
# System startup script for OpenSM
#
# LSB compatible service control script; see http://www.linuxbase.org/spec/
#
# chkconfig: - 09 91
# description:  Manage OpenSM
#
### BEGIN INIT INFO
# Provides: opensmd
# Required-Start: $network $remote_fs openibd
# Required-Stop: $null
# Default-Start: 2 3 5
# Default-Stop: 0 1 2 6
# Short-Description: OpenSM daemon
# Description: Activates/Deactivates OpenSM to start at boot time.
### END INIT INFO
#
# Copyright 2006 PathScale, Inc.  All Rights Reserved.
#
# This Software is licensed under one of the following licenses:
#
# 1) under the terms of the "Common Public License 1.0" a copy of which is
#    available from the Open Source Initiative, see
#    http://www.opensource.org/licenses/cpl.php.
#
# 2) under the terms of the "The BSD License" a copy of which is
#    available from the Open Source Initiative, see
#    http://www.opensource.org/licenses/bsd-license.php.
#
# 3) under the terms of the "GNU General Public License (GPL) Version 2" a
#    copy of which is available from the Open Source Initiative, see
#    http://www.opensource.org/licenses/gpl-license.php.
#
# Licensee has the right to choose one of the above licenses.
#
# Redistributions of source code must retain the above copyright
# notice and one of the license notices.
#
# Redistributions in binary form must reproduce both the above copyright
# notice, one of the license notices in the documentation
# and/or other materials provided with the distribution.

# Check for missing binaries (stale symlinks should not happen)
# Note: Special treatment of stop for LSB conformance
OPENSM_BIN=/usr/sbin/opensm
test -x $OPENSM_BIN || { echo "$OPENSM_BIN not installed"; 
	if [ "$1" = "stop" ]; then exit 0;
	else exit 5; fi; }

# Handover daemon for updating guid2lid cache file
SLDD_BIN=/usr/sbin/sldd.sh
test -x $SLDD_BIN || { SLDD_BIN=/usr/bin/sldd.sh; }

test -x $SLDD_BIN || { echo "$SLDD_BIN not installed";
    if [ "$1" = "stop" ]; then exit 0;
    else exit 5; fi; }

# Check for existence of needed config file and read it
OPENSM_CONFIG=/etc/sysconfig/opensm
test -r $OPENSM_CONFIG || { echo "$OPENSM_CONFIG not existing";
	if [ "$1" = "stop" ]; then exit 0;
	else exit 6; fi; }

# Read config	
. $OPENSM_CONFIG

# Only use ONBOOT option if called by a runlevel directory.
# Therefore determine the base, follow a runlevel link name ...
base=${0##*/}
link=${base#*[SK][0-9][0-9]}
# ... and compare them
if [ $link == $base ] ; then
    ONBOOT=yes
fi

# Check if OpenSM configured to start automatically
if [[ -z $ONBOOT || "$ONBOOT" != "yes" ]]; then
    exit 0
fi

# Source LSB init functions
# providing start_daemon, killproc, pidofproc, 
# log_success_msg, log_failure_msg and log_warning_msg.
# This is currently not used by UnitedLinux based distributions and
# not needed for init scripts for UnitedLinux only. If it is used,
# the functions from rc.status should not be sourced or used.
#. /lib/lsb/init-functions

# Shell functions sourced from /etc/rc.status:
#      rc_check         check and set local and overall rc status
#      rc_status        check and set local and overall rc status
#      rc_status -v     be verbose in local rc status and clear it afterwards
#      rc_status -v -r  ditto and clear both the local and overall rc status
#      rc_status -s     display "skipped" and exit with status 3
#      rc_status -u     display "unused" and exit with status 3
#      rc_failed        set local and overall rc status to failed
#      rc_failed <num>  set local and overall rc status to <num>
#      rc_reset         clear both the local and overall rc status
#      rc_exit          exit appropriate to overall rc status
#      rc_active        checks whether a service is activated by symlinks
. /etc/rc.status

# Reset status of this service
rc_reset

# Setting OpenSM start parameters
RUN_SLDD="no"
OPTIONS="-B"
test "$DEBUG"         -a "$DEBUG"   != "none"     && OPTIONS="${OPTIONS} -d ${DEBUG}"
test "$LMC"           -a "$LMC"     != "0"        && OPTIONS="${OPTIONS} -l ${LMC}"
test "$MAXSMPS"       -a "$MAXSMPS" != "0"        && OPTIONS="${OPTIONS} -maxsmps ${MAXSMPS}"
test "$REASSIGN_LIDS" -a "$REASSIGN_LIDS" != "no" && OPTIONS="${OPTIONS} -r"
test "$SWEEP"         -a "$SWEEP"   != "10"       && OPTIONS="${OPTIONS} -s ${SWEEP}"
test "$TIMEOUT"       -a "$TIMEOUT" != "200"      && OPTIONS="${OPTIONS} -t ${TIMEOUT}"
test "$OSM_LOG"       -a "$OSM_LOG" != "/var/log/opensm.log" && OPTIONS="${OPTIONS} -f ${OSM_LOG}"
test "$VERBOSE"       -a "$VERBOSE" != "none"     && OPTIONS="${OPTIONS} ${VERBOSE}"
test "$UPDN"          -a "$UPDN"    != "off"      && OPTIONS="${OPTIONS} -u"
test "$GUID_FILE"     -a "$GUID_FILE" != "none"   && OPTIONS="${OPTIONS} -a ${GUID_FILE}"
test "$GUID"          -a "$GUID"    != "none"     && OPTIONS="${OPTIONS} -g ${GUID}"
test "$CACHE_OPTIONS" -a "$CACHE_OPTIONS" != "none" && OPTIONS="${OPTIONS} --cache-options"
test "$HONORE_GUID2LID" -a "$HONORE_GUID2LID" != "none" -o "${OSM_HOSTS}" -a $(echo -n ${OSM_HOSTS} | wc -w | tr -d '[:space:]') -gt 1 && OPTIONS="${OPTIONS} --honor_guid2lid" && RUN_SLDD="yes"

test "$PORT_NUM" && PORT_FLAG="${PORT_NUM}" || PORT_FLAG=1

# Return values acc. to LSB for all commands but status:
# 0	  - success
# 1       - generic or unspecified error
# 2       - invalid or excess argument(s)
# 3       - unimplemented feature (e.g. "reload")
# 4       - user had insufficient privileges
# 5       - program is not installed
# 6       - program is not configured
# 7       - program is not running
# 8--199  - reserved (8--99 LSB, 100--149 distrib, 150--199 appl)
# 
# Note that starting an already running service, stopping
# or restarting a not-running service as well as the restart
# with force-reload (in case signaling is not supported) are
# considered a success.

case "$1" in
    start)
        if [ ! -d /sys/class/infiniband ]; then
            echo "Please load Infiniband driver first"
            rc_failed
            rc_exit
            exit
        fi    
    
        if test "${RUN_SLDD}" == "yes"; then
            echo -n "Starting sldd "
            /sbin/startproc $SLDD_BIN
            rc_status -v
        fi

        echo -n "Starting opensm "
        ## Start daemon with startproc(8). If this fails
        ## the return value is set appropriately by startproc.
        /sbin/startproc -q $OPENSM_BIN $OPTIONS

        # Remember status and be verbose
        rc_status -v
        ;;
    stop)
        if /sbin/checkproc $SLDD_BIN; then
            echo -n "Shutting down sldd "
            /sbin/killproc $SLDD_BIN
            rc_status -v
        fi

        echo -n "Shutting down opensm "
        ## Stop daemon with killproc(8) and if this fails
        ## killproc sets the return value according to LSB.

        /sbin/killproc -TERM $OPENSM_BIN

        # Remember status and be verbose
        rc_status -v
        ;;
    try-restart|condrestart)
        ## Do a restart only if the service was active before.
        ## Note: try-restart is now part of LSB (as of 1.9).
        ## RH has a similar command named condrestart.
        if test "$1" = "condrestart"; then
            echo "${attn} Use try-restart ${done}(LSB)${attn} rather than condrestart ${warn}(RH)${norm}"
        fi
        $0 status
        if test $? = 0; then
            $0 restart
        else
            rc_reset	# Not running is not a failure.
        fi
        # Remember status and be quiet
        rc_status
        ;;
    restart)
        ## Stop the service and regardless of whether it was
        ## running or not, start it again.
        $0 stop
        $0 start

        # Remember status and be quiet
        rc_status
        ;;
    force-reload)
        ## Signal the daemon to reload its config. Most daemons
        ## do this on signal 1 (SIGHUP).
        ## If it does not support it, restart the service if it
        ## is running.

        echo -n "Reload service opensm "
        ## if it supports it:
        /sbin/killproc -HUP $OPENSM_BIN
        #touch /var/run/opensm.pid
        rc_status -v

        ## Otherwise:
        #$0 try-restart
        #rc_status
        ;;
    reload)
        ## Like force-reload, but if daemon does not support
        ## signaling, do nothing (!)

        # If it supports signaling:
        echo -n "Reload service opensm "
        /sbin/killproc -HUP $OPENSM_BIN
        #touch /var/run/opensm.pid
        rc_status -v
        
        ## Otherwise if it does not support reload:
        #rc_failed 3
        #rc_status -v
        ;;
    status)
        echo -n "Checking for service opensm "
        ## Check status with checkproc(8), if process is running
        ## checkproc will return with exit status 0.

        # Return value is slightly different for the status command:
        # 0 - service up and running
        # 1 - service dead, but /var/run/  pid  file exists
        # 2 - service dead, but /var/lock/ lock file exists
        # 3 - service not running (unused)
        # 4 - service status unknown :-(
        # 5--199 reserved (5--99 LSB, 100--149 distro, 150--199 appl.)
        
        # NOTE: checkproc returns LSB compliant status values.
        /sbin/checkproc $OPENSM_BIN
        # NOTE: rc_status knows that we called this init script with
        # "status" option and adapts its messages accordingly.
        rc_status -v
        ;;
    probe)
        ## Optional: Probe for the necessity of a reload, print out the
        ## argument to this init script which is required for a reload.
        ## Note: probe is not (yet) part of LSB (as of 1.9)

        test "${OPENSM_CONFIG}" -nt /var/run/opensm.pid && echo reload
        ;;
    *)
        echo "Usage: $0 {start|stop|status|try-restart|restart|force-reload|reload|probe}"
        exit 1
        ;;
esac
rc_exit

